// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <dirent.h>
#include <fnmatch.h>

#include "globals.hh"
#include "PingusError.hh"

#include "ThemeSelector.hh"

ThemeSelector::ThemeSelector()
{
}

ThemeSelector::~ThemeSelector()
{
}

void
ThemeSelector::select()
{
  readdir(pingus_datadir);
}

void
ThemeSelector::readdir(string path)
{
  DIR* dp;
  dirent* de;
      
  string pathname;
  string::size_type pos = 0; 
  string::size_type last_pos = 0; 
  bool exit_for = false;

  cout << "ThemeSelector" << endl;
  for(pos = path.find(":", last_pos);
      !exit_for;
      last_pos = pos + 1, pos = path.find(":", last_pos))
    {
      if (pos == string::npos) {
	pathname = path.substr(last_pos, string::npos);
	exit_for = true;
      } else {
	pathname = path.substr(last_pos, pos - last_pos);
      }

      pathname += "/themes";

      // After we have the directory name, open it and read its
      // content
      dp = opendir(pathname.c_str());
    
      if (!dp) {
	cout << "Warrning: Couldn't open directory: " << pathname << endl;
      } else {
	while ((de = ::readdir(dp)) != NULL) {
	  if (fnmatch("*.plt", de->d_name, FNM_PATHNAME) == 0) {
	    try { 
	      //entry.push_back(FileSelectorEntry(pathname + "/" + de->d_name));
	      cout << (pathname + "/" + de->d_name) << endl;
	    }
	    catch (PingusError err) {
	      cout << "Warning: " << err.message << endl;
	    }
	  }
	} // BUG, errors aren't checked very well
	closedir(dp);
      }
    }
}
/* EOF */
